Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 690128 - =media-video/ffmpeg-4.1.4[hardcoded-tables] fails to build: undefined reference to `avpriv_request_sample'
Summary: =media-video/ffmpeg-4.1.4[hardcoded-tables] fails to build: undefined referen...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: media-video herd
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: ffmpeg-4
  Show dependency tree
 
Reported: 2019-07-18 07:13 UTC by Sergey S. Starikoff
Modified: 2019-08-22 13:49 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log.xz (build.log.xz,44.32 KB, application/x-xz)
2019-07-18 07:13 UTC, Sergey S. Starikoff
Details
environment.xz (environment.xz,26.99 KB, application/x-xz)
2019-07-18 07:13 UTC, Sergey S. Starikoff
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Sergey S. Starikoff 2019-07-18 07:13:30 UTC
Created attachment 583372 [details]
build.log.xz

# emerge -pqv '=media-video/ffmpeg-4.1.4::gentoo'
[ebuild     U ] media-video/ffmpeg-4.1.4 [4.1.3] USE="X alsa bzip2 encode gpl hardcoded-tables iconv mp3 postproc vorbis xcb xvid zlib (-altivec) -amr -amrenc (-appkit) -bluray -bs2b -cdio -chromaprint -chromium -codec2 -cpudetection -debug -doc -fdk -flite -fontconfig -frei0r -fribidi -gcrypt -gme -gmp -gnutls -gsm -iec61883 -ieee1394 -jack -jpeg2k -kvazaar -ladspa -libaom -libass -libcaca -libdrm -libilbc -libressl -librtmp -libsoxr -libv4l -libxml2 -lv2 -lzma (-mipsdspr1) (-mipsdspr2) (-mipsfpu) (-mmal) -modplug -network -openal -opencl -opengl -openh264 -openssl -opus -oss -pic -pulseaudio -rubberband -samba -sdl -snappy -speex -srt -ssh -static-libs -svg -test -theora -threads -truetype -twolame -v4l -vaapi -vdpau -vpx -wavpack -webp -x264 -x265 -zeromq -zimg -zvbi" ABI_X86="(64) -32 (-x32)" CPU_FLAGS_X86="3dnow 3dnowext mmx mmxext sse sse2 sse3 -aes -avx -avx2 -fma3 -fma4 -sse4_1 -sse4_2 -ssse3 -xop" FFTOOLS="aviocat cws2fws ffescape ffeval ffhash fourcc2pixfmt graph2dot ismindex pktdumper qt-faststart sidxindex trasher" VIDEO_CARDS="-nvidia" 

Fails to build with the following error message:

/usr/lib/gcc/x86_64-pc-linux-gnu/8.3.0/../../../../x86_64-pc-linux-gnu/bin/ld: libavcodec/qdm2_tablegen.o: in function `build_table':
qdm2_tablegen.c:(.text+0x36a): undefined reference to `avpriv_request_sample'
collect2: error: ld returned 1 exit status
make: *** [/var/tmp/portage/media-video/ffmpeg-4.1.4/work/ffmpeg-4.1.4/ffbuild/common.mak:155: libavcodec/qdm2_tablegen] Error 1

Complete build log is attached.

# emerge --info '=media-video/ffmpeg-4.1.4::gentoo'
Portage 2.3.66 (python 3.6.5-final-0, default/linux/amd64/17.0, gcc-8.3.0, glibc-2.29-r2, 4.9.184-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-4.9.184-gentoo-x86_64-AMD_Athlon-tm-_II_X2_250_Processor-with-gentoo-2.6
KiB Mem:     1793072 total,     37184 free
KiB Swap:    8000364 total,   7376388 free
Timestamp of repository gentoo: Mon, 15 Jul 2019 00:45:01 +0000
sh bash 4.4_p23-r1
ld GNU ld (Gentoo 2.32 p2) 2.32.0
app-shells/bash:          4.4_p23-r1::gentoo
dev-java/java-config:     2.2.0-r4::gentoo
dev-lang/perl:            5.28.2-r1::gentoo
dev-lang/python:          2.7.15::gentoo, 3.5.5::gentoo, 3.6.5::gentoo
dev-util/cmake:           3.14.3::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/openrc:          0.41.2::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r3::gentoo, 1.13.4-r2::gentoo, 1.16.1-r1::gentoo
sys-devel/binutils:       2.32-r1::gentoo
sys-devel/gcc:            8.3.0-r1::gentoo
sys-devel/gcc-config:     2.0::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 4.14-r1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.29-r2::gentoo
Repositories:

gentoo
    location: /usr/portage/gentoo
    sync-type: webrsync
    sync-umask: 022
    sync-uri: rsync://gw-1.caotus.ru/gentoo-portage/
    sync-user: portage:portage
    priority: -1000

local
    location: /usr/portage/local
    masters: gentoo

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="@FREE"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /etc/env.d /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php7.3/ext-active/ /etc/php/cgi-php7.3/ext-active/ /etc/php/cli-php7.3/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=native -O2 -pipe"
DISTDIR="/var/distfiles"
EMERGE_DEFAULT_OPTS="--ask --verbose --autounmask=n"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs buildsyspkg config-protect-if-modified distlocks downgrade-backup ebuild-locks fixlafiles ipc-sandbox merge-sync metadata-transfer multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirror.yandex.ru/gentoo-distfiles/                 ftp://mirror.yandex.ru/gentoo-distfiles/                 http://ftp.corbina.net/pub/Linux/gentoo/                 ftp://ftp.corbina.net/pub/Linux/gentoo/"
LANG="C"
LC_ALL=""
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="ru ru_RU"
MAKEOPTS="-j2"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_EXTRA_OPTS="--exclude-from=/etc/portage/rsync_excludes"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 ac3 acl alsa amd64 avi berkdb bold bzip2 cdr cli consolekit crypt cups cxx dbus djvu dri dvd flac fortran gdbm gif gtk iconv inotify jpeg libtirpc lock mp3 multilib ncurses nls nptl ogg openmp pam pcre pdf png policykit qt3support readline seccomp session ssl tcpd thunar tiff udev udisks unicode utf8 vorbis xattr xcb xulrunner zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="3dnow 3dnowext mmx mmxext popcnt sse sse2 sse3 sse4a" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="evdev" KERNEL="linux" L10N="ru" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" NETBEANS_MODULES="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6" RUBY_TARGETS="ruby24" USERLAND="GNU" VIDEO_CARDS="radeon" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS
Comment 1 Sergey S. Starikoff 2019-07-18 07:13:53 UTC
Created attachment 583374 [details]
environment.xz
Comment 2 Arthur Zamarin 2019-07-19 06:19:24 UTC
I'm using this USE combination:

USE="X alsa bzip2 encode gpl hardcoded-tables iconv libass librtmp mp3 network openssl postproc threads vaapi vorbis x264 x265 zlib (-altivec) -amr -amrenc (-appkit) -bluray -bs2b -cdio -chromaprint -chromium -codec2 -cpudetection -debug -doc -fdk -flite -fontconfig -frei0r -fribidi -gcrypt -gme -gmp -gnutls -gsm -iec61883 -ieee1394 -jack -jpeg2k -kvazaar -ladspa -libaom -libcaca -libdrm -libilbc -libressl -libsoxr -libv4l -libxml2 -lv2 -lzma (-mipsdspr1) (-mipsdspr2) (-mipsfpu) (-mmal) -modplug -openal -opencl -opengl -openh264 -opus -oss -pic -pulseaudio -rubberband -samba -sdl -snappy -speex -srt -ssh -static-libs -svg -test -theora -truetype -twolame -v4l -vdpau -vpx -wavpack -webp -xcb -xvid -zeromq -zimg -zvbi" ABI_X86="(64) -32 (-x32)" CPU_FLAGS_X86="aes avx avx2 fma3 mmx mmxext sse sse2 sse3 sse4_1 sse4_2 ssse3 -3dnow -3dnowext -fma4 -xop" FFTOOLS="aviocat cws2fws ffescape ffeval ffhash fourcc2pixfmt graph2dot ismindex pktdumper qt-faststart sidxindex trasher" VIDEO_CARDS="-nvidia"

Also fails with the mentioned above. But, using the patch c8232e50074f6f9f9b0674d0a5433f49d73a4e50, which can be found here https://github.com/FFmpeg/FFmpeg/commit/c8232e50074f6f9f9b0674d0a5433f49d73a4e50 . This fixed the building and passed the tests run.

But, this patch sets the call to empty using a define, so I'm not sure if it is the correct way. Now running my system with this patch, hope it works.
Comment 3 tt_1 2019-07-19 09:48:11 UTC
Does USE="hardcoded-tables" trigger this bug, then?
Comment 4 Arthur Zamarin 2019-07-19 10:08:51 UTC
Flag disabled:
With USE="-hardcoded-tables" and without the patch: compile and test passes.
With USE="-hardcoded-tables" and with the patch: compile and test passes.

Flag enabled:
With USE="hardcoded-tables" and without the patch: compile fails with this bug.
With USE="hardcoded-tables" and with the patch: compile and test passes.

So in conclusion, it happens only with USE="hardcoded-tables", and the patch should fix it (I hope the tests cover this functionality and there are no regressions). What is also interesting is that this patch is older that the 4.1.4 release, so it should have been included in upstream - so what happened?
Comment 5 tt_1 2019-07-22 09:41:47 UTC
I can confirm, USE="hardcoded-tables" triggers this bug. 

You should add this to the ffmpeg-4.0 tracker, so that people actually notice it.
Comment 6 Sergey S. Starikoff 2019-07-22 10:37:19 UTC
(In reply to tt_1 from comment #5)
> I can confirm, USE="hardcoded-tables" triggers this bug. 
> 
> You should add this to the ffmpeg-4.0 tracker, so that people actually
> notice it.

Probably, upstream reporting requires some more knowledge of package's build system, than I have.
Could you do it?
Comment 7 Alexis Ballier gentoo-dev 2019-08-22 13:42:36 UTC
this is fixed in 4.2
Comment 8 Arthur Zamarin 2019-08-22 13:49:40 UTC
Maybe it is a good idea to mark this bug in version 4.1.4 (maybe 4.1.*) in the tree?
Maybe remove the USE flag itself for those versions? Maybe mask it for all affected versions?

I'm afraid of some package hark dependency on <ffmpeg-4.2 and failing to build and repeating this bug.